﻿Imports System.Globalization
Imports mshtml

Public Class Evaluate
    Dim us As New Globalization.CultureInfo("en-US")
    WithEvents wb As C_WebBrowser
    Private Sub BtnEval_Loaded(sender As Object, e As RoutedEventArgs) Handles BtnEval.Loaded
        wb = New C_WebBrowser(WebBrowser2)
    End Sub
    Private Sub BtnEval_Click(sender As Object, e As RoutedEventArgs) Handles BtnEval.Click
        Try
            Dim style As NumberStyles = NumberStyles.Any
            Dim sFn As String = TBEvalFn.Text
            If InStr(sFn, "=") Then
                Dim vs() As String = Split(sFn, "=")
                TBEvalFn.Text = vs(0)
                Exit Sub
            End If
            Dim from, [to], [step] As Double, decimals As Int32
            If Double.TryParse(TBEvalFrom.Text, style, us, from) AndAlso
            Double.TryParse(TBEvalTo.Text, style, us, [to]) AndAlso
            Double.TryParse(TBEvalStep.Text, style, us, [step]) AndAlso
            Int32.TryParse(TBEvalDecimals.Text, decimals) Then
                If from >= [to] Then
                    MsgBox(msg8.num(9) + vbCrLf + " 'From' greater or equal to 'To'.") ' invalid argument
                    Exit Sub
                End If
                Dim graph2 As New Graph()
                Dim mP As matrixParser = Nothing
                Try
                    mP = graph2.draw2(sFn, from, [to], [step], decimals, CHKRounding.IsChecked)
                Catch ex As Exception
                End Try
                Dim vars As VarsAndFns = mP.getVars
                If vars.getNamesList.Length <> 1 Then
                    Dim format As String = msg8.num(69)
                    Dim msg As String = ""
                    Dim sVars() = vars.getNamesList
                    If sVars.LongLength = 0 Then
                        format = msg8.num(16)
                        msg = String.Format(format, "x") ' variable not found
                    Else
                        msg = String.Format(format, TBEvalFn.Text, Join(vars.getNamesList, ","))
                    End If
                    MsgBox(msg)
                    Exit Sub
                End If
                Dim sVar As String = vars.getNamesList(0)
                Dim sImg As String = ""
                If graph2 IsNot Nothing Then
                    sImg = graph2.ToBase64
                End If
                Dim s As String
                If graph2.lst.Count Then
                    s = "<table align=""left"" cellspacing='2' cellpadding='2' border='1'>"
                    If mP.ret.exprMtx.Rows + mP.ret.exprMtx.Cols = 2 Then
                        s += "<tr style='text-align:center'><th>" + sVar + "</th><th>" +
                        sFn + "</th></tr>" + vbCrLf
                    Else
                        s += "<tr style='text-align:center'><th>#</th><th>" +
                        "Value" + "</th></tr>" + vbCrLf
                    End If
                    With graph2
                        For i As Int32 = 0 To .lst.Count - 1
                            s += "<tr style='text-align:right;'><td>" + .lst.Item(i).Key + "</td><td>" +
                                    .lst.Item(i).Value +
                                "</td></tr>" + vbCrLf
                        Next
                    End With
                    s += "</table>"
                End If
                wb.Dsp(s, "", False, sImg)
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub TBGotFocus(sender As Object, e As RoutedEventArgs) Handles _
        TBEvalFn.GotFocus, TBEvalFrom.GotFocus, TBEvalTo.GotFocus, TBEvalStep.GotFocus, TBEvalDecimals.GotFocus
        Try
            Dim tb As TextBox = CType(sender, TextBox)
            tb.SelectAll()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub CHKRounding_Checked(sender As Object, e As RoutedEventArgs) _
        Handles CHKRounding.Checked, CHKRounding.Unchecked
        Try
            Dim chk As CheckBox = CType(sender, CheckBox)
            TBEvalDecimals.IsEnabled = chk.IsChecked
        Catch ex As Exception

        End Try
    End Sub


    Private Sub BtnFind_Click(sender As Object, e As RoutedEventArgs) Handles BtnFind.Click
        Try
            'Dim sFind As String = TBFind.Text
            Dim document As HTMLDocument = CType(wb.webbrowser1.Document, HTMLDocument)
            Dim body As IHTMLElement = document.getElementById("bd")
            wb.webbrowser1.Focus()
            System.Windows.Forms.SendKeys.SendWait("^f")
            'Dim pos As Int32 = InStr(body.innerText, sFind)
            'If pos Then
            'For i = 1 To 5
            '    Threading.Thread.Sleep(10)
            '    System.Windows.Forms.Application.DoEvents()
            'Next
            'System.Windows.Forms.SendKeys.SendWait(sFind)
            'For i = 1 To 5
            '    Threading.Thread.Sleep(10)
            '    System.Windows.Forms.Application.DoEvents()
            'Next
            'System.Windows.Forms.SendKeys.SendWait("{ENTER}")
            'For i = 1 To 5
            '    Threading.Thread.Sleep(10)
            '    System.Windows.Forms.Application.DoEvents()
            'Next
            'System.Windows.Forms.SendKeys.SendWait("%{F4}")
            'End If
        Catch ex As Exception

        End Try
    End Sub
End Class
